package geniusweb.connection;

/**
 * a socket for a general two-way connection
 *
 * @param <INTYPE> the type of incoming messages
 * @param <OUTTYPE> the type of outgoing messages
 */
public interface Connectable<INTYPE, OUTTYPE> {
	/**
	 * creates the connection. Only called if not yet connected.
	 * 
	 * @param connection the new connection
	 */
	void connect(Connection<INTYPE, OUTTYPE> connection);

	/**
	 * Removes the connection from a connectable; the previously given
	 * connection can not be used anymore after this call. Only called if
	 * previously connected.
	 * 
	 */
	void disconnect();
}
