package geniusweb.connection;

import tudelft.utilities.listener.DefaultListenable;

/**
 * Default implementation of connection. Connection implementors only need to
 * implement the send (which moves the data sent into the connection to the
 * other side) and they can call {@link DefaultListenable#notifyChange(Object)}
 * to inform the users of the connection that something came in from the other
 * side.
 *
 * @param <INTYPE> the datatype of objects received from the other side
 * @param <OUTTYPE> the datatype of objects sent to the other side.
 */
public abstract class DefaultConnection<INTYPE, OUTTYPE> extends
		DefaultListenable<INTYPE> implements Connection<INTYPE, OUTTYPE> {
}
